]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame - rpm.macros
- fallback to ~/rpm/{RPMS,SRPMS,BUILD} of they don't exist in topdir (old mode)
[packages/rpm-build-macros.git] / rpm.macros
CommitLineData
397b586d 1# $Revision$, $Date$
f51bfb2f
ER
2# PLD Linux rpm macros.
3# <http://www.pld-linux.org/>
d54662bf 4
2b05614d 5# can be used by builder script to check for version
98c5c988
ER
6%rpm_build_macros %(R="$Revision$"; RR="${R##: }"; echo ${RR%%?})
7
e05017c1 8%epoch 0
3241033b 9%x8664 x86_64 amd64 ia32e
9c404149 10
ba1fdedc 11# kernel compiler
345d14e5 12%kgcc %{__cc}
d2e1bc22 13%kgcc_package gcc
ba1fdedc 14
46763914 15# compiler version
69bcfbf3 16%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
de629430 17%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
46763914 18
69bcfbf3 19%__rm /bin/rm --interactive=never
36eccf0d 20
33040789 21# Build system path macros.
69bcfbf3
ER
22%__autoconf autoconf %{?debug:-Wall}
23%__automake automake -a -c -f --foreign
24%__autopoint autopoint --force
25
26# add parallel build flags: -jN
a5656a95 27#
11ecb0a1
ER
28# if you want to disable parallel build do:
29# echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
a5656a95 30#
11ecb0a1
ER
31%__make /usr/bin/make %{?_smp_mflags}
32%__scons /usr/bin/scons %{?_smp_mflags}
33%__waf /usr/bin/waf %{?_smp_mflags}
b8f83d42 34%__cmake /usr/bin/cmake
a5656a95
JR
35
36%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
37 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
f93109a0 38
83094b62 39%__gettextize { \
8a995cff 40 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
3241033b 41 gettextize --copy --force --no-changelog; \
97589b6e 42 else \
3241033b 43 gettextize --copy --force --no-changelog --intl; \
8a995cff
JB
44 fi; \
45 if [ ! -f po/Makevars ]; then \
3241033b 46 cp -f po/Makevars{.template,}; \
8a995cff 47 fi; \
8a995cff 48}
f93109a0 49
50%__glib_gettextize glib-gettextize --copy --force
51%__gnome_doc_common gnome-doc-common --copy
fb59e475 52%__gnome_doc_prepare gnome-doc-prepare --copy --force
f93109a0 53%__gtkdocize gtkdocize --copy
54%__intltoolize intltoolize --copy --force
c26f1b59 55%__libtoolize libtoolize --copy --force --install
33040789 56
751c2bdd
ER
57# topdir is where builder script lives,
58# fallback to old style if SPECS/SOURCES dirs were found.
59%_topdir %{expand:%%global _topdir %(
60 if [ -d SPECS -a -d SOURCES ]; then
61 # old style rpmdir: in topdir
ddeaa8de 62 readlink -m .
751c2bdd
ER
63 elif [ -d ../SPECS -a -d ../SOURCES ]; then
64 # old style rpmdir: in subdir
ddeaa8de 65 readlink -m ..
751c2bdd
ER
66 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
67 # if old style rpm dir exist, go with it
68 echo $HOME/rpm; \
69 elif [ -x ../builder -a ! -d ../builder ]; then
70 # relative new style rpmdir: in package dir
ddeaa8de 71 readlink -m ..
751c2bdd
ER
72 elif [ -x builder -a ! -d builder ]; then
73 # relative new style rpmdir: in packages
ddeaa8de 74 readlink -m .
751c2bdd
ER
75 elif [ -x packages/builder -a ! -d packages/builder ]; then
76 # relative new style rpmdir: packages dir in current dir
ddeaa8de 77 readlink -m packages
751c2bdd
ER
78 else
79 # fallback to new style rpmdir
80 echo $HOME/rpm/packages
81 fi; \
82)}%_topdir
1052b4b8 83
751c2bdd
ER
84# if %{_topdir}/SPECS exists, it's old style structure
85%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
86%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
1052b4b8
ER
87
88# BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
89# if they don't exist assume we are having custom topdir (which is not named as
90# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
e3229028
ER
91%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD; fi)}%_builddir
92%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
93%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
384e1b2b 94
81e450f7
ER
95# The number of cvs changelog entries kept when building package.
96%_buildchangelogtruncate 20
97
6a5eda77 98%dependencytracking %{nil}
3241033b 99
e5da9169
ER
100# Relations between package names that cause dependency loops
101# with legacy packages that cannot be fixed. Relations are
102# specified as
103# p>q
104# where package p has a Requires: on something that package q Provides:
105#
106# XXX Note: that there cannot be any whitespace within the string "p>q",
107# and that both p and q are package names (i.e. no version/release).
108%_dependency_whiteout %{nil}
109
810fa5c4 110#-----------------------------------------------------------------
111#
112# (re)definition of %{rpm*flags} with %filterout_* support
b5e977c5
ER
113# BuildRequires: awk
114# BuildRequires: rpmbuild(macros) >= 1.315
810fa5c4 115#
116# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
09a90176 117# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
118# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
98e7f050 119# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
09a90176 120# %rpmldflags = %optldflags - %filterout_ld
810fa5c4 121#
122# Regular expressions are supported, but to avoid some character be treated
123# as regular expression it must be escaped twice.
124
125%filter_out \
7b6f1112 126 for (i = 1; i in I; i++) { A=0; \
810fa5c4 127 for (f in F) { \
128 if (I[i] ~ "^" F[f] "$") A=1; \
129 }; \
130 if (!A) printf(I[i] FS); \
131 }
132
133%rpmcflags %(awk 'BEGIN {
134 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
09a90176 135 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
810fa5c4 136 %{filter_out}
137}')
138
139%rpmcxxflags %(awk 'BEGIN {
09a90176 140 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
141 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
810fa5c4 142 %{filter_out}
143}')
144
98e7f050
AM
145%rpmcppflags %(awk 'BEGIN {
146 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
147 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
148 %{filter_out}
149}')
150
810fa5c4 151%rpmldflags %(awk 'BEGIN {
c05a0741 152 split("%{?optldflags}",I);
810fa5c4 153 split("%{?filterout_ld}",F)
154 %{filter_out}
155}')
156
25f52d1a 157# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
158# but, don't use it, better use gcc as linker
159%ld_rpmldflags %(awk 'BEGIN {
160 split("%{rpmldflags}",F);
161 for (f in F) {
162 s = F[f];
163 if (s ~ /^-Wl,/) {
164 s = substr(s,5);
165 gsub(/,/," ",s);
166 };
167 printf(s FS);
168 };
169}')
170
8ef644e5 171#-----------------------------------------------------------------
172#
173# Generate a command which cleans environment, leaving only the
174# most important variables.
175# If any spec requires any additional environment it should
176# redefine %_preserve_env in following manner:
177#
178# # ADDITIONAL_VAR is required because [a good reason here]
82d10503 179# %define _preserve_env ADDITIONAL_VAR
8ef644e5 180
57ba0f59 181%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
8ef644e5 182
bb597f2b
AM
183# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
184%_clean_env %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
0bdc88ec 185 split("%{?_preserve_env}", P);
a363d727
ER
186 for (i in P) {
187 p = P[i];
82d10503
ER
188 if (!ENVIRON[p] || d[p]) {
189 continue;
8ef644e5 190 }
82d10503
ER
191 d[p] = 1;
192 split(ENVIRON[p], V, "");
193 val = p "=";
194 for (j = 1; j in V; j++) {
195 v = V[j];
196 if (v == q)
197 v = qq;
198 else if (v == "\\"")
199 v = q2q;
200 else if (v == "\\\\")
201 v = "\\\\\\\\";
202 else
203 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
204 val = val "" v;
205 }
206 printf(val " ");
8ef644e5 207 }
208}')
209
9c404149 210#-----------------------------------------------------------------
9f4ce098 211%configure2_13 { \
9c404149
AM
212 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
213 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
214 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 215 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 216 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
e9d801f4 217 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
98e7f050 218 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
8983c4c4
AM
219 %{?__cc:CC="%{__cc}" ; export CC ; } \
220 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 221 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 222 --host=%{_target_platform} \
9c404149
AM
223 --prefix=%{_prefix} \
224 --exec-prefix=%{_exec_prefix} \
225 --bindir=%{_bindir} \
226 --sbindir=%{_sbindir} \
227 --sysconfdir=%{_sysconfdir} \
228 --datadir=%{_datadir} \
229 --includedir=%{_includedir} \
230 --libdir=%{_libdir} \
231 --libexecdir=%{_libexecdir} \
232 --localstatedir=%{_localstatedir} \
233 --sharedstatedir=%{_sharedstatedir} \
234 --mandir=%{_mandir} \
235 --infodir=%{_infodir} \
b6c5da52 236 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 237 %{dependencytracking} \
9c404149
AM
238}
239
39b9534b
ER
240%cmake { \
241CC="%{__cc}" \
242CXX="%{__cxx}" \
243CFLAGS="%{rpmcflags}" \
244CXXFLAGS="%{rpmcxxflags}" \
12513dc1 245LDFLAGS="%{rpmldflags}" \
89f4ca1f
ER
246%{__cmake} \
247}
248
89f4ca1f
ER
249%scons { \
250%{__scons} \
5c76736d
ER
251 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
252 CFLAGS="${CFLAGS:-%rpmcflags}" \
253 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
254 FFLAGS="${FFLAGS:-%rpmcflags}" \
98e7f050 255 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
5c76736d
ER
256 %{?__cc:CC="%{__cc}"} \
257 %{?__cxx:CXX="%{__cxx}"} \
258 libsuffix=%{_lib} \
259 prefix=%{_prefix} \
39b9534b
ER
260}
261
6339d32d 262# waf. see waf.spec
6339d32d 263%waf { \
6339d32d
ER
264CC="%{__cc}" \
265CXX="%{__cxx}" \
9e244007 266CPP="%{__cpp}" \
6339d32d
ER
267CFLAGS="%{rpmcflags}" \
268CXXFLAGS="%{rpmcxxflags}" \
269%{__waf} \
6339d32d
ER
270}
271
4a6b0d54 272#----------------------------------------------------------------
9bacbb5b 273#%configure_cache 0
fe6c4bdd 274%configure_cache_file %{buildroot}.configure.cache
73f832b3 275
e84cd836 276%configure {./configure \
4a6b0d54
AF
277 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
278 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 279 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 280 FFLAGS="${FFLAGS:-%rpmcflags}" \
e9d801f4 281 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
98e7f050 282 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
8983c4c4
AM
283 %{?__cc:CC="%{__cc}"} \
284 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 285 --host=%{_target_platform} \
4a6b0d54
AF
286 --build=%{_target_platform} \
287 --prefix=%{_prefix} \
288 --exec-prefix=%{_exec_prefix} \
289 --bindir=%{_bindir} \
290 --sbindir=%{_sbindir} \
291 --sysconfdir=%{_sysconfdir} \
292 --datadir=%{_datadir} \
293 --includedir=%{_includedir} \
294 --libdir=%{_libdir} \
295 --libexecdir=%{_libexecdir} \
296 --localstatedir=%{_localstatedir} \
297 --sharedstatedir=%{_sharedstatedir} \
298 --mandir=%{_mandir} \
299 --infodir=%{_infodir} \
b6c5da52 300 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 301 %{dependencytracking} \
9bacbb5b 302 %{?configure_cache:--cache-file=%{configure_cache_file}} \
4a6b0d54
AF
303}
304
611a25d5 305# Simple macros to simplify adding bconded options to configure scripts.
306# Each macro requires bcond name and accepts optional option name, if option
307# isn't specified bcond name is used as option name. Options returning
308# --with and --enable also allow third argument which will be added as value
309# ( --with-option=value or --enable-option=value ) in case or positive
310# condition, but won't be added otherwise ( nothing or just --disable-option ).
311
312# Requirements:
313# BuildRequires: rpmbuild(macros) >= 1.527
314
315# Usage example:
316# %{__enable bcond} - returns --enable-bcond iff build condition is set
317# %{__disable bcond option} - returns --enable-option iff bcond is not set
318# %{__enable_disable bcond option value} - returns --enable-option=value if
319# bcond is set, returns --disable-option otherwise
320
321# expand bconds to --enable-something and --disable-something
322%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
323%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
324%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
325
326# same as above, but condition inverted
327%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
328%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
329%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
330
331# expand bconds to --with-something and --without-something
332%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
333%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
334%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
335
336# same as above, but condition inverted
337%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
338%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
339%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
340
341#-----------------------------------------------------------------
342
b3b1397b
ER
343# overload to insert debuginfo package
344%prep \
345%if 0%{?_enable_debug_packages}\
346%{debug_package}\
347%endif\
348%%prep\
349%{nil}
350
9c404149 351# Location of autoconf macros
7f0f4a79 352%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
9c404149 353
e2804f99 354# Location of omf files
7f0f4a79 355%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
e2804f99 356
e987a186 357# Location of pkgconfig files
9a4e877a 358%_pkgconfigdir /usr/%{_lib}/pkgconfig
36219c36
JB
359# noarch pkgconfig files
360%_npkgconfigdir /usr/share/pkgconfig
e987a186 361
486b0b5f 362# Location of desktop files
363%_desktopdir /usr/share/applications
86dff2d0 364%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 365
481463e9 366# Location of pixmaps for applnk/desktop files
e1f0a822 367%_pixmapsdir /usr/share/pixmaps
9c404149 368
481463e9 369# Location of themable icons for applnk/desktop files
b36c8e2a 370%_iconsdir /usr/share/icons
371
e987a186
JB
372# Location of fonts directories
373%_fontsdir /usr/share/fonts
374
b3282f3f 375# Location of Gtk and associated libraries documentation
fe6c4bdd 376%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 377
fc4d7771 378# Location of KDE documentation
fe6c4bdd 379%_kdedocdir %{_defaultdocdir}/kde/HTML
fc4d7771 380
5869828c 381# unsermake script
382%__unsermake /usr/share/unsermake/unsermake
383
9c404149 384# Current date
8cf161e2 385%date %(LC_ALL=C date +"%a %b %d %Y")
9c404149 386
9c404149
AM
387# Example files, programs, scripts...
388%_examplesdir /usr/src/examples
389
c8f7e820 390# Alternative kernel type/version
261729d9 391%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
c8f7e820 392
8377d27d 393# The directory holding Linux kernel sources
261729d9 394%_kernelsrcdir /usr/src/linux%{_alt_kernel}
8377d27d 395
c0fe61f0
ER
396# SysV-style initscripts dir
397%_initddir /etc/rc.d/init.d
398
9c404149 399# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 400%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 401
c924d9d8
ER
402# -n drm to generate kernel%{_alt_kernel}-drm dependency
403%releq_kernel(n:) %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
404%releq_kernel_up(n:) %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
405%releq_kernel_smp(n:) %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
8bf3719d 406
c924d9d8 407# -s post to generate Requires(post) dependency
63d9963a
ER
408%requires_releq_kernel(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel
409%requires_releq_kernel_up(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_up
410%requires_releq_kernel_smp(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
8bf3719d 411
410df6e8
ER
412# Requires name = version-release
413%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
8cf161e2 414# Requires: name = version
91d2f1eb 415%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
8cf161e2 416# Requires: name = version (version based on querying package %2)
0d3e64c0 417%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
01a9f990 418
c94807f3 419%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
b9d5d440 420
421# kernel version-release handling
95125403
ER
422%__kernel_ver %{expand:%%global __kernel_ver %( \\
423 Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
424 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
425 echo ${Z:-ERROR}; \\
1a7d3518 426)}%__kernel_ver
95125403 427
c94807f3
ER
428%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
429%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
430%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
431%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
87be1cf0 432
6262f001
ER
433# `uname -r` to be used in @release field
434%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
435
e00dd7f6 436# sgml macros
3241033b
ER
437%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
438%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
439%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
440%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
441%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
442%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 443%docbook_sgmlcat_fix() { for l in \
444'' \
445' -- default decl --' \
446'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
447' -- hacks for opensp --' \
448'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
449'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
450'' \
451; do echo $l; done >> %1 \
452}
453
eea64748
ER
454# vim - "
455
4f044018
ER
456# minimum file size needed for compressed documents.
457# just smaller files than this get larger when compressed.
a88ae20f
ER
458# some stats:
459# - 0 byte file compressed was 25 bytes .gz
460# - 39 byte file was compressed as 57
461# - with test/test.spec@man 158 byte file was compressed also 158
462%_min_compress_bytes 159
4f044018 463
9c404149
AM
464#-----------------------------------------------------------------
465# find and gzip all files in %{_mandir} and %{infodir}
466#
467# Requires: xargs, find
468#
469#%no_install_post_compress_docs 1
470%__spec_install_post_compress_docs { \
53d5af13 471%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
4e10ec06 472 for i in /usr/share/man /usr/X11R6/man; do \
9c404149 473 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
4e10ec06 474 echo "Compress man pages: $i"; \
4f044018
ER
475 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
476 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
6375241c
ER
477 find $RPM_BUILD_ROOT$i -type l | while read a; do \
478 m=$(readlink $a); \
479 rm -f $a; \
480 echo .so ${m##*/} > $a; \
481 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
482 done; \
4f044018 483 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
9c404149
AM
484 fi; \
485 done; \
728ad671
JB
486 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
487 echo "Compress info pages: %{_infodir}"; \
488 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
489 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
490 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
4e10ec06 491 fi; \
53d5af13 492}; __spec_install_post_compress_docs } }
9c404149
AM
493
494#-----------------------------------------------------------------
495# Strip executable binaries and shared object files
496#
497# Requires: find, awk, strip, cut, xargs
498#
a2ad2754
JB
499# Special macros which affect this process:
500#%no_install_post_strip 1 # disable stripping at all
501#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
502#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
503#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
504#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
505#
9c404149 506%__spec_install_post_strip {%{!?debug: \
53d5af13 507%{!?no_install_post_strip:__spec_install_post_strip() { \
98a06bad 508if [ -d "$RPM_BUILD_ROOT" ]; then \
eea64748
ER
509 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
510 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
511 if [ "$modulelist" ]; then \
512 modulecount=$(echo "$modulelist" | wc -l); \
737fefdc 513 printf "Stripping %d kernel modules..." $modulecount; \
3df8db34
ER
514 echo "$modulelist" | xargs -l512 chmod u+w; \
515 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
516 echo "DONE"; \
517 fi; \
eea64748 518 fi; \
0ac49134 519 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
f89ccb5f
JB
520 if [ -n "$filelist" ]; then \
521 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
522 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
523 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
a2ad2754 524 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
f89ccb5f 525 if [ -n "$elfexelist" ]; then \
4d5370ac 526 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
f89ccb5f
JB
527 chmod u+w $elfexelist; \
528 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
529 echo "DONE"; \
530 fi; \
531 if [ -n "$elfsharedlist" ]; then \
4d5370ac 532 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
f89ccb5f
JB
533 chmod u+w $elfsharedlist; \
534 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
535 echo "DONE"; \
536 fi; \
537 if [ -n "$archiveslist" ]; then \
4d5370ac 538 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
f89ccb5f
JB
539 chmod u+w $archiveslist; \
540 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
541 echo "DONE"; \
542 fi; \
98a06bad 543 fi; \
0ac49134
ER
544 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
545 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
546 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
f89ccb5f 547 if [ -n "$filelist_all" ]; then \
4d5370ac 548 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
a2ad2754 549 chmod u+w $filelist_all; \
f89ccb5f 550 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
322f84b9 551 echo "DONE"; \
9c404149 552 fi; \
f89ccb5f 553 if [ -n "$filelist_unneeded" ]; then \
4d5370ac 554 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
a2ad2754 555 chmod u+w $filelist_unneeded; \
f89ccb5f 556 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
322f84b9 557 echo "DONE"; \
8f74418b 558 fi; \
f89ccb5f 559 if [ -n "$filelist_debug" ]; then \
4d5370ac 560 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
a2ad2754 561 chmod u+w $filelist_debug; \
f89ccb5f 562 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
322f84b9 563 echo "DONE"; \
9f0d4f36 564 fi; \
53d5af13 565fi; }; __spec_install_post_strip } } }
3241033b 566
fc5d7e20 567#-----------------------------------------------------------------
568# remove all RPATH from executable binaries and shared object files
569#
570# Requires: find, awk, cut, xargs, chrpath, uname
571#
a2ad2754
JB
572# Special macros which affect this process
573#%no_install_post_chrpath 1 # disable chrpath at all
574#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
575#
fc5d7e20 576%__spec_install_post_chrpath {%{!?debug: \
53d5af13 577%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
9f0d4f36 578if [ -d "$RPM_BUILD_ROOT" ]; then \
0ac49134 579 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
98a06bad 580 if [ -n "$files" ]; then \
d5517264 581 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
3401a2cd 582 fi; \
98a06bad 583 if [ -n "$objs" ]; then \
4d5370ac 584 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
98a06bad
ER
585 echo "$objs" | \
586 while read file; do \
587 rpath= ; \
588 chmod u+w "$file"; \
5541bf26 589 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
eda6b510
AM
590 case $dir in \
591 '$ORIGIN' ) \
592 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
593 else rpath="$rpath:$dir" ; fi ; \
594 continue ; \
595 ;; \
596 esac ; \
f9abaddb
AM
597 newdir=$(readlink -m "$dir"); \
598 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
98a06bad
ER
599 case $dir in \
600 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
601 echo "remove-rpath: $dir in $file"; \
602 ;; \
603 * ) \
604 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
605 else rpath="$rpath:$dir" ; fi ; \
606 ;; \
607 esac ; \
608 done ; \
609 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
610 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
611 done; \
612 fi; \
53d5af13 613fi; }; __spec_install_post_chrpath } } }
3241033b 614
611a25d5 615# vim: "
616
d366d7e0
AM
617#-----------------------------------------------------------------
618# Find all shared object files with unresolved symbols. Warn
619# and terminate if any found (termination can be turned off by define).
620#%no_install_post_check_so 1
621%__spec_install_post_check_so { \
622 __spec_install_post_check_so() { \
623 fail=0; \
624 printf "Searching for shared objects with unresolved symbols..."; \
34906a2d 625 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
7df9ddfc 626 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
d366d7e0
AM
627 done ; \
628 echo " DONE"; \
14ae3117 629 %{!?no_install_post_check_so:[ $fail -eq 1 ] && : || :;} \
d366d7e0
AM
630}; __spec_install_post_check_so }}
631
d72c185f 632#-----------------------------------------------------------------
ccb8ae8d 633# Find and gzip all kernel modules
634#
635# Requires: find
636#
fe6c4bdd 637#%no_install_post_compress_modules 1
ccb8ae8d 638%__spec_install_post_compress_modules { \
53d5af13 639%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
f3bfe4ac 640 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
f3bfe4ac 641 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
642 if [ "$q" ]; then \
643 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
644 echo "$q" | xargs -r %{__gzip} -9nf; \
645 echo "DONE"; \
646 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
647 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
648 fi; \
3241033b 649 fi; \
53d5af13 650}; __spec_install_post_compress_modules } }
9c404149 651
ef64802f
ER
652# Remove common Perl files we don't package
653%__spec_install_post_perl_clean {\
654%{!?no_install_post_perl_clean: \
655%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
656} }
657
83094b62 658#-----------------------------------------------------------------
0e4cb4dd 659# Update GConf2 schemas
83094b62 660#
661# Requires: GConf2
662#
46885239 663%gconf_schema_install() \
307ac6c9
ER
664 umask 022; \
665 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
666 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
f27cf2fd 667%{nil}
46885239 668
669%gconf_schema_uninstall() \
24336a54 670if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
3241033b 671 umask 022; \
24336a54
ER
672 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
673 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f27cf2fd 674fi; \
f93109a0 675%{nil}
676
677#-----------------------------------------------------------------
678# Update desktop MIME database
c0a4caa0 679# requires: desktop-file-utils
c3bcd10e 680%update_desktop_database() {{ \
f93109a0 681 umask 022; \
fb59e475 682 /usr/bin/update-desktop-database -q; \
c00bf95c
MB
683};} \
684%{nil}
f93109a0 685
c3bcd10e
ER
686%update_desktop_database_post %update_desktop_database
687
688%update_desktop_database_postun() {{ \
f27cf2fd 689if [ "$1" = "0" ]; then \
c00bf95c 690 %update_desktop_database \
f27cf2fd 691fi; \
c00bf95c
MB
692};} \
693%{nil}
f93109a0 694
fb59e475 695#-----------------------------------------------------------------
696# Update shared MIME info database
697# requires: shared-mime-info
698#
c3bcd10e 699%update_mime_database() {{ \
fb59e475 700 umask 022; \
701 /usr/bin/update-mime-database %{_datadir}/mime; \
c00bf95c
MB
702};} \
703%{nil}
fb59e475 704
705#-----------------------------------------------------------------
706# Update icon cache
707# requires: gtk+
708#
c3bcd10e 709%update_icon_cache() {{ \
fb59e475 710 umask 022; \
072f4b80 711 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
c00bf95c
MB
712};} \
713%{nil}
fb59e475 714
f93109a0 715#-----------------------------------------------------------------
716# Update scrollkeeper database
717# requires: scrollkeeper
718#
719%scrollkeeper_update_post() \
f93109a0 720 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 721%{nil}
f93109a0 722
723%scrollkeeper_update_postun() \
f27cf2fd 724if [ "$1" = "0" ]; then \
f93109a0 725 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 726fi; \
f93109a0 727%{nil}
728
9c404149
AM
729#-----------------------------------------------------------------
730# post %install sequence:
731# - autodeps exceptions
732# - compress all man and info pages,
733# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 734# - compress kernel modules if any
9c404149
AM
735
736###################################################################
737# Requires/Provides automation
3e202b06 738# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
338726a6 739#
2892b5df
JB
740%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
741%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
742%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
743%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
744%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
c94807f3 745
338726a6
JB
746#%_noautocompressdoc %{nil}
747#
8f74418b
MM
748%_missing_doc_files_terminate_build 1%{nil}
749%_unpackaged_files_terminate_build %{nil}
8781dc74 750# (X)emacs support
d77dcb61 751%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
c94807f3
ER
752%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
753%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
25043cd4 754
02b58f60
JK
755%__php_provides %{nil}
756%__php_requires %{nil}
757%__perl_provides %{nil}
758%__perl_requires %{nil}
fa3497cd 759%__mono_provides %{nil}
760%__mono_requires %{nil}
25043cd4
AF
761
762# Perl specific macro definitions.
c94807f3
ER
763%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
764%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
765%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
766%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
767%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
768%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
25043cd4 769
45c00b39 770# Ruby
c94807f3
ER
771%__ruby /usr/bin/ruby
772%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
773%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
774%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
775%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
776%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
777%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
778%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
751cfc9e 779%ruby_rdocdir /usr/share/rdoc
c94807f3 780%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
669604db
ER
781%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
782%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
45c00b39 783
7ccf7643 784%php_pear_dir /usr/share/pear
7813c433 785%php_data_dir /usr/share/php
c94807f3
ER
786%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
787%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
788%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
25043cd4 789
0c5d1b9b 790# extract php/zend api versions
c94807f3 791%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
e0d35dd1 792%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
c94807f3
ER
793%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
794%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
795%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
796%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
797%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
798%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
c1b2705c
ER
799
800# helper macro
f952c0f3 801%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
c1b2705c
ER
802
803# macros for public use
804# for php extensions (php-pecl)
68b68193 805%requires_php_extension %{__php_api_requires modules_api php_api_version} \
415f4a1a 806%{__php_api_requires zend_module_api} \
f952c0f3
ER
807%{__php_api_requires -v %php_major_version debug php_debug} \
808%{__php_api_requires -v %php_major_version thread-safety zend_zts}
68b68193 809
c1b2705c
ER
810# for zend extensions
811%requires_zend_extension %{__php_api_requires zend_module_api} \
68b68193 812%{__php_api_requires zend_extension_api} \
f952c0f3
ER
813%{__php_api_requires -v %php_major_version debug php_debug} \
814%{__php_api_requires -v %php_major_version thread-safety zend_zts}
c1b2705c 815
934c685f
ER
816# for php pdo modules (php-pecl-PDO_*)
817%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
818
6c3b8203
ER
819# for using PHP post scripts. for PHP >= 5.0
820%php_webserver_restart \
821[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
578e7794 822[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
8e2cfc36 823if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
ba1800dc
ER
824 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
825 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
826 %service -q php-fcgi restart \
827 fi \
828fi \
8e2cfc36
ER
829if [ -x /etc/rc.d/init.d/php-fpm ]; then \
830 %service -q php-fpm restart \
831fi \
6c3b8203
ER
832%{nil}
833
834# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
835%php4_webserver_restart \
836[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
578e7794 837[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
8e2cfc36 838if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
ba1800dc
ER
839 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
840 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
841 %service -q php-fcgi restart \
842 fi \
843fi \
6c3b8203
ER
844%{nil}
845
578e9248 846# X.org helper macros
434ab5a2
ER
847%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
848%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
849
c94807f3
ER
850%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
851%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
852%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
853%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
854%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
611a25d5 855# vim: '
578e9248 856
434ab5a2 857%requires_xorg_xserver_extension \
97486460
AM
858%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
859%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
860%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
861%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
434ab5a2
ER
862%{nil}
863
864%requires_xorg_xserver_xinput \
97486460
AM
865%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
866%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
867%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
868%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
434ab5a2
ER
869%{nil}
870
871%requires_xorg_xserver_font \
97486460
AM
872%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
873%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
874%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
875%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
434ab5a2
ER
876%{nil}
877
878%requires_xorg_xserver_videodrv \
97486460
AM
879%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
880%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
881%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
882%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
434ab5a2 883%{nil}
578e9248 884
15d7cc4a
ER
885# TCL specific macro definitions.
886# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
887%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
888%tcl_sitearch %{_libdir}/tcl%{tcl_version}
889%tcl_sitelib %{_datadir}/tcl%{tcl_version}
890
25043cd4
AF
891# Python specific macro definitions.
892# python main version
2383a9da 893%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
25043cd4
AF
894
895# directories
2383a9da 896%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
3241033b 897%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 898%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 899%py_incdir /usr/include/python%{py_ver}
7ccf7643 900%py_sitedir %{py_libdir}/site-packages
ef7ec0a8 901%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 902%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
903
904# pure python modules compilation
3241033b 905%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 906
3241033b 907%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
908
909# Software written in Python language require Python with main version
e63cd81d 910%pyrequires_eq() Requires: %1
25043cd4 911
4bf34b55
AF
912# Python 3.x
913# python main version
e9f00395 914%__python3 python3
4bf34b55
AF
915%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
916
917# directories
918%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
919%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
920%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
921%py3_incdir /usr/include/python%{py3_ver}
922%py3_sitedir %{py3_libdir}/site-packages
923%py3_sitescriptdir %{py3_scriptdir}/site-packages
924%py3_dyndir %{py3_libdir}/lib-dynload
925
926# pure python modules compilation
927%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
928
929%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
930
f12c2314 931# Hardlink binary identical .pyc and .pyo files
f12c2314 932%__spec_install_post_py_hardlink {\
53d5af13 933%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
f35a1d62
ER
934local a b c=0 t=0; \
935if [ -d "$RPM_BUILD_ROOT" ]; then \
936 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
937 while read a; do \
938 b="${a%.pyc}.pyo"; \
939 if cmp -s "$a" "$b"; then \
940 ln -f "$a" "$b"; \
941 c=$((c + 1)); \
942 fi; \
943 t=$((t + 1)); \
944 done < __rpm_pyc; \
945 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
946 rm -f __rpm_pyc; \
947fi; \
53d5af13 948}; __spec_install_post_py_hardlink } }
f12c2314 949
9227b3f9 950# remove python sources, so that check-files won't complain
f12c2314 951%py_postclean() \
0f82e280 952for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
820792a9 953 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
f12c2314
AF
954done \
955%{nil}
956
4bf34b55
AF
957%py3_postclean() \
958for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
959 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
960done \
961%{nil}
962
0fc5cff8 963# depmod macro
964%depmod() { \
f6148427 965umask 022; \
0fc5cff8 966if [ -e /boot/System.map-%1 ]; then \
3241033b 967 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 968else \
3241033b
ER
969 if [ -e /boot/System.map ]; then \
970 /sbin/depmod -a -F /boot/System.map %1; \
971 else \
972 /sbin/depmod -a %1; \
973 fi \
0fc5cff8 974fi; \
975}
976
2afc6e64 977# XMMS specific macros
c94807f3
ER
978%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
979%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
980%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
981%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
982%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
983%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
984%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
985%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
986%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
987%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
988
c28a1d6a 989%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/')}%_target_base_arch
d1537778 990
848c0d68 991# user/group checking macros
992#
993# Usage:
994# %userremove myuser
995#
996%userremove /usr/lib/rpm/user_group.sh user del
997%groupremove /usr/lib/rpm/user_group.sh group del
998#
999# Usage:
1000# if %usertestrm myuser; then
1001# /usr/sbin/userdel -r myuser
1002# Note:
1003# use these macros only if you need to call userdel/groupdel with
1004# a non-standard option or take an extra action; otherwise use the
1005# %userremove/%groupremove macros
1006#
1007%usertestrm /usr/lib/rpm/user_group.sh user testrm
1008%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
1009# user group membership management macros
1010#
1011# Usage:
efbc7726 1012# %addusertogroup [-q] myuser agroup
08d9b1f6 1013#
efbc7726
ER
1014# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1015#
1016# Requirements:
1017# BuildRequires: rpmbuild(macros) >= 1.515
2b29e157
ER
1018%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1019%{nil}
72fcfcb3 1020
1021# banner support (useful in {pre,post}{,un} and triggers)
1022#
1023# Usage:
aa41c920 1024# %banner name [-a] [-e] [-n] [-tn] <<EOF
72fcfcb3 1025# the banner text, the banner text
aa41c920
ER
1026# the banner text, and following line
1027#EOF
1028# You can use any form of here-document, <<'EOF' <<-EOT will do.
1029# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1030#
72fcfcb3 1031# -a - append to the banner
a8b9562a 1032# -e - send to stderr instead of stdout
628754cb 1033# -n - no show banner (overrides -t)
1034# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
276a7b45
ER
1035#
1036# Tests:
1037# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1038# rpm -E 'date | %banner -e banner' > m; sh -x m
1039#
afb54f6c 1040%banner(aent:) ( \
1b334fe4 1041RPM_SCRIPTVERBOSITY=5 \
1042[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1043if [ -x /usr/bin/banner.sh ]; then \
aa41c920 1044 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 1045else \
a8b9562a 1046 CMD="cat%{-e: >&2}" \
1b334fe4 1047fi \
276a7b45
ER
1048eval $CMD %{?2:%2}%{?3: %3}) \
1049%{nil}
628754cb 1050
990bd03f 1051# useradd/groupadd macros
4c73bc69 1052# Author: Elan Ruusamäe <glen@pld-linux.org>
90627280
ER
1053#
1054# Usage:
1055# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1056# [-g initial_group] [-G group[,...]] login
1057#
1058# -u uid. REQUIRED
1059# -g gid/group. REQUIRED
1060# -s defaults to /bin/false
1061# -d defaults to /usr/share/empty
1062# -c No default
1063# -r is accepted but ignored (it's always set)
6bd4c218 1064# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
1065# rpm specific flags
1066# -P package name. defaults to %{name}
1067#
90627280 1068%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
1069%{!-u:%{error:useradd: Required argument -u missing}} \
1070%{!-g:%{error:useradd: Required argument -g missing}} \
1071%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
1072if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1073 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1074 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1075 exit 1 \
1076 fi \
1077else \
1078 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1079 /usr/sbin/useradd \\\
b5a7d552 1080 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
1081 -u %{-u*} \\\
1082 -r \\\
1083 -d %{-d*}%{!-d:/usr/share/empty} \\\
1084 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 1085 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
1086 -g %{-g*} \\\
1087 %{-M} \\\
1088 %{-G:-G %{-G*}} \\\
1aac682a 1089 %{expand:%{%{#}}} 1>&2 || exit $? \
bcf63b58 1090 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
90627280 1091fi;
611a25d5 1092# vim: "
90627280 1093
90627280
ER
1094# Usage:
1095# %groupadd [-P package] [-g gid] group
1096#
1097# -g gid. REQUIRED
1098#
1099# Sample:
1100# %groupadd -P %{name}-base -g %{gid} %{name}
1101
1102%groupadd(g:P:rfo) \
9ba02ba9
ER
1103%{!-g:%{error:groupadd: Required argument -g missing}} \
1104%{!?1:%{error:groupadd: Required parameter group missing}} \
637962e6 1105if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
90627280
ER
1106 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1107 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1108 exit 1 \
1109 fi \
1110else \
1111 echo "Adding group %{1} GID=%{-g*}." \
1aac682a 1112 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
bcf63b58 1113 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
90627280 1114fi;
7cb77741 1115
7c50f037 1116# webapp macros
4c73bc69 1117# Author: Elan Ruusamäe <glen@pld-linux.org>
35663282
ER
1118#
1119# The config is installed/removed inside trigger, this means that you can any
1120# time install apache1/apache/lighttpd package and the configuration file is
fe6c4bdd 1121# updated. if you don't need the config for various reason for specific
35663282
ER
1122# webserver, just remove the symlink from config directory using webapp
1123# program. the trigger will not recreate the symlink on upgrades. In other
1124# words the config is linked to webserver config directory on first install of
1125# PACKAGE or WEBSERVER.
1126#
7c50f037
ER
1127# Add package's webserver config to webserver webapps dir.
1128# Usage:
aea687a7 1129# %webapp_register [-f] WEBSERVER WEBAPP
35663282 1130#
aea687a7 1131%webapp_register(f) \
35663282 1132%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
aea687a7 1133if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
35663282
ER
1134 /usr/sbin/webapp register %1 %2\
1135fi\
694a8f2e 1136# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
5d3a09a3 1137if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
16897aea 1138 %{expand:%service -q %%1 reload}\
35663282
ER
1139fi\
1140%{nil}
1141
1142# Remove package's config from webserver webapps dir.
35663282 1143# Usage:
531c0efc
ER
1144# %webapp_register [-f] WEBSERVER WEBAPP
1145%webapp_unregister(f) \
35663282
ER
1146%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1147# remove link if either of the packages are gone \
5d3a09a3 1148if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
df979130 1149 /usr/sbin/webapp unregister %1 %2\
16897aea 1150 %{expand:%service -q %%1 reload}\
35663282
ER
1151fi \
1152%{nil}
1153
462b26fa 1154# service macro.
4c73bc69 1155# Author: Elan Ruusamäe <glen@pld-linux.org>
462b26fa
ER
1156#
1157# calls usual service restart on package %post, but skips the restart if
1158# administrator has disabled automatic service restarts in either global
1159# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1160#
462b26fa 1161# Usage:
7377b5ca 1162# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa 1163#
a0bbe604 1164# -q be silent when service isn't started (for scriplets restaring other package's services)
7377b5ca 1165# -n NOOP mode, do not actually restart service
462b26fa 1166#
7377b5ca
ER
1167# Requirements:
1168# BuildRequires: rpmbuild(macros) >= 1.268
1169# Requires: rc-scripts
1170# -n option:
1171# BuildRequires: rpmbuild(macros) >= 1.450
1172%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
6aedae62
ER
1173
1174
f9aa75bf
ER
1175# Java macros. based on jpackage macros.java
1176#
1177# Root directory where all Java VMs/SDK/JREs are installed.
2d4659a1 1178%_jvmdir %{_libdir}/jvm
f9aa75bf
ER
1179
1180# Root directory where all Java VMs/SDK/JREs expose their jars
2d4659a1 1181%_jvmjardir %{_libdir}/jvm-exports
f9aa75bf
ER
1182
1183# Root directory for all Java VM/SDK/JRE's private things.
1184%_jvmprivdir %{_libdir}/jvm-private
1185
1186# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
2d4659a1 1187%_jvmlibdir %{_libdir}/jvm
f9aa75bf
ER
1188
1189# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1190%_jvmdatadir %{_datadir}/jvm
1191
1192# Root directory for all configurations parts of Java VM/SDK/JRE's
1193%_jvmsysconfdir %{_sysconfdir}/jvm
1194
1195# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
f5ed4276 1196%_jvmcommonlibdir %{_libdir}/jvm-common
f9aa75bf
ER
1197
1198# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
f5ed4276 1199%_jvmcommondatadir %{_datadir}/jvm-common
f9aa75bf
ER
1200
1201# Root directory for all common configurations parts of Java VM/SDK/JRE's
f5ed4276 1202%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
f9aa75bf
ER
1203
1204# Directory where arch-specific (JNI) version-independent jars are installed.
2d4659a1 1205%_jnidir %{_libdir}/java
f9aa75bf 1206
c94807f3 1207%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
6aedae62 1208
a9254650 1209%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
fe6c4bdd 1210%jar %{java_home}/bin/jar
c94807f3 1211%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
fe6c4bdd
ER
1212%javac %{java_home}/bin/javac
1213%javadoc %{java_home}/bin/javadoc
6aedae62 1214
fe6c4bdd 1215%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
6aedae62
ER
1216
1217%jpackage_script() \
3ca65b87
ER
1218install -d $RPM_BUILD_ROOT%{_bindir}\
1219cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
6aedae62
ER
1220#!/bin/sh\
1221#\
1222# %{name} script\
1223# JPackage Project <http://www.jpackage.org/>\
1224\
1225# Source functions library\
1226. %{_javadir}-utils/java-functions\
1227\
1228# Source system prefs\
3ca65b87 1229if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
fe6c4bdd 1230 . %{_sysconfdir}/java/%{name}.conf\
6aedae62
ER
1231fi\
1232\
1233# Source user prefs\
3ca65b87
ER
1234if [ -f $HOME/.%{name}rc ]; then\
1235 . $HOME/.%{name}rc\
6aedae62
ER
1236fi\
1237\
1238# Configuration\
1239MAIN_CLASS=%1\
1240BASE_FLAGS=%2\
1241BASE_OPTIONS=%3\
3ca65b87 1242BASE_JARS="%(echo %4 | tr ':' ' ')"\
6aedae62
ER
1243\
1244# Set parameters\
1245set_jvm\
3ca65b87
ER
1246set_classpath $BASE_JARS\
1247set_flags $BASE_FLAGS\
1248set_options $BASE_OPTIONS\
6aedae62
ER
1249\
1250# Let's start\
3ca65b87 1251run "$@"\
6aedae62
ER
1252EOF
1253
06f11871
ER
1254# jpackage 1.7
1255# Directory for maven depmaps
1256#
1257%_mavendepmapdir /etc/maven
1258%_mavendepmapfragdir /etc/maven/fragments
1259
1260#
1261# add_to_depmap adds an entry to the depmap. The arguments are:
1262#
1263# %1 the original groupid
1264# %2 the original artifact id
1265# %3 the version
1266# %4 the new groupid
1267# %5 the new artifactid
1268#
1269
1270%add_to_maven_depmap() \
1271install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1272cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1273<dependency>\
1274 <maven>\
1275 <groupId>%1</groupId>\
1276 <artifactId>%2</artifactId>\
1277 <version>%3</version>\
1278 </maven>\
1279 <jpp>\
1280 <groupId>%4</groupId>\
1281 <artifactId>%5</artifactId>\
1282 <version>%3</version>\
1283 </jpp>\
1284</dependency>\
1285\
1286EOF\
1287%{nil}
1288
1289#==============================================================================
1290#
1291# update_maven_depmap updates the main maven depmap
1292#
1293%update_maven_depmap() \
1294echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1295if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1296cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1297fi\
1298echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1299
02c5f99a 1300# JAVA macros specific for PLD
1301
1302# Directory for tomcat context configuration files
1303%_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
06f11871 1304
59d3ebe9 1305# PEAR install macros
4c73bc69 1306# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1307#
1308# Usage:
f7ecf326 1309# %%pear_package_setup ...
dfce8b19 1310#
59d3ebe9 1311# -a # - also unpack SOURCE#. for PEAR bootstrapping
dfce8b19 1312# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
59d3ebe9 1313# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
f7ecf326
ER
1314# -D - pass -D to %setup (so the build dir is not removed)
1315# -c - register channel from local channel.xml file
dfce8b19
ER
1316#
1317# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1318# destination hierarchy. you should copy the tree to buildroot after
1319# patching/reorganizing with %%pear_package_install.
1320#
1321# additionally BUILDROOT is stripped from files and files are converted to UNIX
1322# line endings.
1323#
1324# the pear install process output is recorded to install.log, you should put it
8763f51e 1325# to %%doc for later debug or just for information.
dfce8b19
ER
1326#
1327# additionally additional-packages.txt is produced if it was detected that the
1328# package has optional dependencies. the file format is suitable of displaying
1329# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1330# automatically added for this file.
59d3ebe9
ER
1331
1332
1333# records install.log and transforms PEAR names to PLD Linux rpm package names.
1334%__pear_install_log \
1335tee install.log \
1336# make post message of optional packages \
f64d1bb2 1337grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
59d3ebe9
ER
1338if [ -s optional-packages.txt ]; then \
1339 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1340else \
1341 rm -f optional-packages.txt \
1342fi \
1343%{nil}
1344
1345# command invoking pear cli
1346%__pear /usr/bin/pear
1347
67a089ff 1348%pear_install(a:n:zD) \
59d3ebe9 1349%__pear \\\
f7ecf326 1350 -c %{builddir}/pearrc \\\
dfce8b19 1351 -d doc_dir=/docs \\\
f7ecf326
ER
1352 -d temp_dir=/tmp \\\
1353 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
dfce8b19
ER
1354 -d bin_dir=%{_bindir} \\\
1355 -d data_dir=%{php_pear_dir}/data \\\
1356 -d test_dir=%{php_pear_dir}/tests \\\
1357 install \\\
59d3ebe9 1358 --packagingroot=%{builddir} \\\
dfce8b19
ER
1359 --offline \\\
1360 --nodeps \\\
1361 %{-f:--force} \\\
67a089ff 1362 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
b872fad7 1363 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
67a089ff
ER
1364%{nil}
1365
1366# The main macro.
1367# using this macro will append optional-packages.txt to the nocompressdoc list
1368# as it's displayed to user after package install. and adding additional gzip
1369# dep is just waste ;)
f7ecf326 1370%pear_package_setup(a:n:zDc:) \
67a089ff
ER
1371%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1372%define builddir %{_builddir}/%{srcdir} \
1373%setup -q -c -T %{-D:-D} -n %{srcdir} \
1374%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1375%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
f7ecf326 1376%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
67a089ff 1377%pear_install \
59d3ebe9
ER
1378%{-z:cd ..} \
1379cat %{-z:$_N/}.install.log | %__pear_install_log \
1380\
dfce8b19 1381# undos sources \
2a80e4cf 1382find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
dfce8b19
ER
1383%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1384%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1385%{nil}
1386
7bef60e8 1387# Copies exctracted PEAR package structure and PEAR registry to buildroot.
4c73bc69 1388# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1389%pear_package_install() \
1390cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1391find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1392# help the developer out a little: \
1393if [ -f _noautoreq ]; then \
1394 echo "AutoReqdep detected:" \
1395 echo "_noautoreq $(cat _noautoreq)" \
1396fi \
1397%{nil}
1398
0d5dd00c
ER
1399
1400# Register OpenLDAP schema.
4c73bc69 1401# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1402#
1403# Usage:
1404# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1405#
1406# -d specify dependant schemas, separated by comma
1407#
1408%openldap_schema_register(d:) \
1409for schema in %*; do \
1410 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1411 %{__sed} -i -e " \
1412 /^include.*local.schema/{ \
1413 iinclude\\t $schema\
1414 } \
1415 " /etc/openldap/slapd.conf \
1416 fi \
1417done \
1418# enable dependant schemas \
1419if [ "%{-d*}" ]; then \
1420 %{__sed} -i -e ' \
1421 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1422 s/^#// \
1423 }' /etc/openldap/slapd.conf \
1424fi \
1425%{nil}
1426
1427# Unregister OpenLDAP schema.
4c73bc69 1428# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1429#
1430# Usage:
1431# %%openldap_schema_unregister %{schemadir}/horde.schema
1432#
1433%openldap_schema_unregister() \
1434for schema in %*; do \
1435 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1436 %{__sed} -i -e " \
1437 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1438 # for symmetry it would be nice if we disable enabled schemas in post, \
1439 # but we really can not do that, it would break something else. \
1440 " /etc/openldap/slapd.conf \
1441 fi \
1442done \
1443%{nil}
1444
b0bc2936 1445%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
d834e0a1 1446
dcc6baf7 1447
1448# Build modules for kernels 2.6
1449# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1450#
1451# Usage:
aa559e46 1452# %build_kernel_modules -m <modules> -C <directory>
dcc6baf7 1453#
1454# remember that proper Makefile is still required
1455# Options:
990bd03f 1456# -m <modules> (required) -- comma-separated list of modules to save,
dcc6baf7 1457# without .ko extension, may be placed in subdirectory
aa559e46 1458# -C <directory> -- change to <directory> before doing anything
dcc6baf7 1459# -p <arg>, -P <arg> -- arguments passeed to make scripts
5a81d83e 1460# -c -- do not execute make clean
dcc6baf7 1461# <additional arguments> -- all additional arguments will be passed to
1462# make modules
1463#
1464# Additional patching supported via here document. Try:
1465# %build_kernel_modules -m module <<'EOF'
1466# your patch script here
1467# EOF
1468# Don't use it unless patching depends on config options.
1469
1470# Developer note: don't touch it unless you know how to handle '\'.
1471# - \ in script expands to nothing
1472# - \\\ in script expands to \
566398b4 1473# - \\\ inside definition expands to nothing
dcc6baf7 1474# - \\\\\\\ inside definition expands to \
1475# - in last line \ has to touch arguments so arguments passing
1476# in new lines (using \) will be supported
1477
5a81d83e 1478%build_kernel_modules(p:P:m:C:c) \
dcc6baf7 1479%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1480 \
1481%define Opts \\\\\\\
1482%if "%{_target_base_arch}" != "%{_arch}" \\\
1483 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
88608ef7 1484 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
dcc6baf7 1485 %else \\\
1486 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1487 %endif \\\
1488%else \\\
88608ef7 1489 CC="%{kgcc}" \\\
dcc6baf7 1490%endif \
88608ef7 1491%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
dcc6baf7 1492 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1493 \
e364bc26 1494%{?-C:cd %{-C*}} \
dcc6baf7 1495compile() { \
ba9de9b2
ER
1496 local L="<" PATCH_SH; \
1497 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
dcc6baf7 1498 set -e -x \
730239f9 1499 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1500 \
730239f9 1501for cfg in ${cfgs:-dist}; do \
dcc6baf7 1502 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1503 \
c546f6fb 1504 rm -rf o \
68cfe9d9 1505 install -d o/include/linux o/arch/powerpc/lib \
dcc6baf7 1506 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1507 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1508 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1509 \
1510 set +x \
1511 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1512 set -x \
1513 \
c768535c 1514 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
dcc6baf7 1515 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1516 %{-p*} %{-P*} \\\
1517 %{MakeOpts} \
1518 %else \
1519 install -d o/include/config \
1520 touch o/include/config/MARKER \
588f1b0b 1521 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
dcc6baf7 1522 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1523 %endif \
1524 \
5a81d83e 1525 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
dcc6baf7 1526 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
f635907b 1527 ${1+"$@"} \\\
5a81d83e 1528 M=$PWD %{MakeOpts}} \
f635907b 1529 \
dcc6baf7 1530 %{__make} -C %{_kernelsrcdir} modules \\\
1531 ${1+"$@"} \\\
1532 M=$PWD %{MakeOpts} \
1533 \
1534 for MODULE in {%{-m*},}; do \
1535 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1536 done \
1537done \
aa559e46 1538%{?-C:cd -} \
dcc6baf7 1539} \
1540compile %{*}\
1541%{nil}
1542
1543
1544# Install kernel modules built by %build_kernel_modules
1545# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1546#
1547# Usage:
1548# %install_kernel_modules -m <modules> -d <directory>
1549#
1550# Options:
990bd03f 1551# -m <modules> (required) -- comma-separated list of modules to install,
dcc6baf7 1552# without .ko extension, may be placed in subdirectory
1553# -d <directory> (required) -- in what subdirectory modules should be
1554# installed (eg. misc, kernel/drivers/net)
1555# -s <suffix> -- suffix to use when installing modules, useful when module
1556# with same name exists in kernel already
1557# -n <file> -- name of modprobe config file to use (without .conf extension)
00395cf1 1558# for defining aliases, only useful with -s
dcc6baf7 1559
1560%install_kernel_modules(m:d:s:n:) \
1561%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1562%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1563%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1564 \
1565%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1566%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
412786d1 1567 \
b279feda 1568__install_kernel_modules() { \
730239f9 1569local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1570 \
1571for MODULE in {%{-m*},}; do \
1572 [ -n "${MODULE}" ] || continue \
730239f9
ER
1573 for cfg in ${cfgs:-dist}; do \
1574 [ "$cfg" = smp ] && suf=smp || suf= \
1575 MNAME=${MODULE##*/} \
1576 install -D ${MODULE}-$cfg.ko \\\
1577 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b9460afb 1578 %{?-s:install -d %{ModprobeD}$suf \
730239f9
ER
1579 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1580 >> %{ModprobeD}$suf/%{-n*}.conf} \
1581 done \
dcc6baf7 1582done \
b279feda 1583} \
1584__install_kernel_modules \
dcc6baf7 1585%{nil}
1586
fa65356c 1587# patchset macros
4c73bc69 1588# Author: Elan Ruusamäe <glen@pld-linux.org>
fa65356c
ER
1589#
1590# Usage:
1591# %patchset_source -f <seq(1) format> <start> [<end>]
1592# %patchset_patch <start> [<end>]
1593#
1594# If <end> is omited, it is assumed to be <start>.
1595#
1596# For example in preamble:
1597# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1598# and in %prep:
1599# %patchset_patch 33 44
1600
1601# generate SourceX urls from range START STOP
1602# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1603# The sources start from 10000
e91610db 1604%patchset_source(f:b:) %(
44f733ef 1605 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1606 start=$(expr $base + %1);
1607 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1608 # we need to call seq twice as it doesn't allow two formats
1609 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1610 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1611 paste %{tmpdir}/__ps{1,2};
1612 rm -f %{tmpdir}/__ps{1,2};
962f9ecf
ER
1613) \
1614%{nil}
fa65356c
ER
1615
1616# apply sources from %patchset_source
1617# -p specify -pX for %patch line
1618# -b base offset: defaults to 10000
1619%patchset_patch(f:p:b:) %(
44f733ef 1620 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1621 start=$(expr $base + %1);
1622 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1623 echo ": patchset_patch %1%{?2: to %2}";
1624 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
962f9ecf
ER
1625) \
1626%{nil}
fa65356c 1627
5730b44b 1628# browser plugins v2
4c73bc69 1629# Author: Elan Ruusamäe <glen@pld-linux.org>
5730b44b
ER
1630#
1631# Usage:
1632# %browser_plugins_add_browser <name> -p <plugindir>
1633#
1634# <name> (required) -- name of the browser. usually %{name}.
1635# -p <plugindir> (required) -- in what directory browser searches for its plugins.
02ebf70f
ER
1636# -b -- default blacklists
1637# -a <arch> override arch
5730b44b
ER
1638#
1639# Example:
1640# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1641
1642%_browserpluginsconfdir /etc/browser-plugins
5e19a4dc 1643%_browserpluginsdir %{_libdir}/browser-plugins
5730b44b
ER
1644%update_browser_plugins /usr/sbin/update-browser-plugins || :
1645
02ebf70f 1646%browser_plugins_add_browser(p:b:a:) \
9efd458e 1647 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
5730b44b 1648 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
02ebf70f
ER
1649 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1650 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
5730b44b
ER
1651 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1652 %{-b:cat >> $blacklist_file %{-b*}} \
1653%{nil}
1654
ad17b654
ER
1655# Helper for LUA.
1656# split string separated by space into quoted list
1657#
4c73bc69 1658# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1659#
1660# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1661%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1662
1663# adjust /etc/shells by adding and removing shells from there
4c73bc69 1664# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1665#
1666# Usage:
d9b789d9
ER
1667# %post -p <lua>
1668# %lua_add_etc_shells /bin/sh /bin/pdksh
ad17b654 1669#
d9b789d9
ER
1670# %preun -p <lua>
1671# if arg[2] == 0 then
1672# %lua_remove_etc_shells /bin/bash /bin/rbash
1673# end
7377b5ca
ER
1674#
1675# Requirements:
d9b789d9
ER
1676# BuildRequires: rpmbuild(macros) >= 1.462
1677#
ad17b654 1678
d9b789d9 1679%lua_add_etc_shells() \
ad17b654
ER
1680t = {}\
1681f = io.open("/etc/shells", "r")\
1682if f then\
1683 for l in f:lines() do t[l]=l; end\
1684 f:close()\
1685end\
1686for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1687 if not t[s] then\
b8c0bc18 1688 print("Adding "..s.." to /etc/shells")\
ad17b654
ER
1689 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1690 end\
1691end\
1692%{nil}
1693
d9b789d9
ER
1694%lua_remove_etc_shells() \
1695t = {}\
1696f = io.open("/etc/shells", "r")\
1697if f then\
1698 for l in f:lines() do t[l]=l; end\
1699 f:close()\
1700end\
1701for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1702 print("Removing "..l.." from /etc/shells")\
1703 t[l] = nil\
1704end\
1705s=""\
1706for _, l in pairs(t) do\
1707 s=s..l.."\\n"\
1708end\
1709io.open("/etc/shells", "w"):write(s)\
1710%{nil}
1711
1712# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1713#
1714# Author: Elan Ruusamäe <glen@pld-linux.org>
1715#
1716# Usage:
1717# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1718# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1719#
1720# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1721#
1722# Requirements:
1723# BuildRequires: rpmbuild(macros) >= 1.429
1724#
1725%add_etc_shells(p) %{-p:<lua>}\
1726%{expand:%%lua_add_etc_shells %*}\
1727%{nil}
1728
ad17b654 1729%remove_etc_shells(p) %{-p:<lua>}\
b8c0bc18 1730%{-p:if arg[2] == 0 then}\
d9b789d9 1731%{expand:%%lua_remove_etc_shells %*}\
750e19f4 1732%{-p:end} \
ad17b654
ER
1733%{nil}
1734
75bd6249
ER
1735# Check syntax for Python files
1736#
1737# Author: Elan Ruusamäe <glen@pld-linux.org>
1738# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1739#
1740# Usage:
1741# %py_lint src
1742#
1743# Requirements:
1744# BuildRequires: python
1745# BuildRequires: rpmbuild(macros) >= 1.469
1746
1747%py_lint() \
1748__py_lint() { \
1749find "$@" -type f -name '*.py' | python -c ' \
1750import sys \
1751import compiler \
1752\
1753err = 0\
1754for f in sys.stdin: \
1755 fd = open(f.strip()) \
1756 c = fd.read() \
1757 fd.close() \
1758 try: \
1759 compiler.parse(c) \
1760 except SyntaxError, e: \
1761 print "py_lint: %s: %s" % (f.strip(), e) \
1762 err = err + 1\
1763\
1764if err: \
1765 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1766 sys.exit(1) \
1767else: \
1768 print >> sys.stderr, "py_lint: Found no syntax errors." \
1769' \
1770}; __py_lint %* \
1771%{nil}
1772
f602e4a0 1773# Undos files
1774#
1775# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1776#
1777# Usage:
1778# %undos list_of_files
1779#
1780# Requirements:
1781# BuildRequires: sed >= 4.0
1782# BuildRequires: rpmbuild(macros) >= 1.533
1783
1784%undos \
1785%{__sed} -i -e 's,\\r$,,'
1786
f51bfb2f 1787# vim:ts=4 sw=4 noet ft=spec
This page took 0.534335 seconds and 4 git commands to generate.